# Contributing

## Versioning

This repository follows the _Semantic Versioning 2.0.0_ specification.

## Preferences

Please do not modify `.gitignore`, `analysis_options.yaml`, and such files. Use
the current settings. Open an issue if you think these files need to be updated.

## Coding Style

- Contributors must avoid writing spaghetti code.
- Contributors must write comprehensive, readable, and performant code.
- Contributors, if needed, should skim the codebase to get an understanding of
  its coding style.

## Commit Messages

Contributors must follow the _Conventional Commits 1.0.0_ specification in their
commit messages.

## Pull Requests

- Contributors must avoid adding pull requests with no prior discussion and
  positive feedback in a corresponding issue.
- There is no guarantee that all pull requests meeting the contribution
  guidelines will be approved and merged.
